from typing import Optional

from cpl_core.database import DatabaseSettings
from cpl_core.database.connection import DatabaseConnectionABC
from mysql.connector.abstracts import MySQLConnectionAbstract
from mysql.connector.cursor import MySQLCursorBuffered


class DBConnection(DatabaseConnectionABC):
    def __init__(self):
        DatabaseConnectionABC.__init__(self)

        self._database: Optional[MySQLConnectionAbstract] = None
        self._cursor: Optional[MySQLCursorBuffered] = None

    @property
    def server(self) -> MySQLConnectionAbstract:
        return self._database

    @property
    def cursor(self) -> MySQLCursorBuffered:
        return self._cursor

    def connect(self, settings: DatabaseSettings):
        # connection = sql.connect(
        #     host=settings.host,
        #     port=settings.port,
        #     user=settings.user,
        #     passwd=CredentialManager.decrypt(settings.password),
        #     charset=settings.charset,
        #     use_unicode=settings.use_unicode,
        #     buffered=settings.buffered,
        #     auth_plugin=settings.auth_plugin,
        #     ssl_disabled=settings.ssl_disabled,
        # )
        # connection.cursor().execute(f"CREATE DATABASE IF NOT EXISTS `{settings.database}`;")
        # self._database = sql.connect(
        #     host=settings.host,
        #     port=settings.port,
        #     user=settings.user,
        #     passwd=CredentialManager.decrypt(settings.password),
        #     db=settings.database,
        #     charset=settings.charset,
        #     use_unicode=settings.use_unicode,
        #     buffered=settings.buffered,
        #     auth_plugin=settings.auth_plugin,
        #     ssl_disabled=settings.ssl_disabled,
        # )
        self._
        self._cursor = self._database.cursor()
